HTMLMarkup subclass:#HTMLAnchor
	instanceVariableNames:'bounds anchorText color'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Documentation'
!


!HTMLAnchor methodsFor:'accessing'!

anchorText
    ^ anchorText

    "Created: 20.5.1996 / 16:19:07 / cg"
!

anchorText:aString
    anchorText := aString

    "Created: 20.5.1996 / 16:19:16 / cg"
!

bounds
    ^ bounds

    "Created: 17.5.1996 / 17:42:09 / cg"
!

bounds:aRectangle
    bounds := aRectangle

    "Created: 17.5.1996 / 17:42:20 / cg"
!

color
    "return color"

    ^ color

    "Created: 21.5.1996 / 23:04:10 / cg"
!

color:something
    "set color"

    color := something.

    "Created: 21.5.1996 / 23:04:10 / cg"
! !

!HTMLAnchor methodsFor:'printing & storing'!

displayString
    ^ 'a ' , self class name ,'(<' , type printString , ' ' , text , '>)'

    "Created: 17.5.1996 / 14:20:51 / cg"
! !

!HTMLAnchor methodsFor:'queries'!

boundsTop
    bounds isNil ifTrue:[^ nil].
    bounds size == 0 ifTrue:[^ nil].
    ^ bounds first top

    "Modified: 21.5.1996 / 10:16:12 / cg"
    "Created: 21.5.1996 / 11:15:57 / cg"
!

hrefString
    ^ self parameterFor:'HREF' orLowerCase:'href'

    "Created: 17.5.1996 / 18:29:50 / cg"
    "Modified: 18.6.1996 / 20:58:24 / cg"
!

isExample
    |t|

    t := self typeString.
    ^ t notNil and:[t asLowercase = 'example']

    "Modified: 17.5.1996 / 16:55:41 / cg"
    "Created: 17.5.1996 / 18:30:25 / cg"
!

srcString
    ^ self parameterFor:'SRC' orLowerCase:'src'

    "Created: 17.5.1996 / 16:52:08 / cg"
    "Modified: 18.6.1996 / 20:58:34 / cg"
! !

!HTMLAnchor  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/HTMLAnchor.st,v 1.9 1996-09-05 17:53:00 cg Exp $'
! !
