HTMLMarkup subclass:#HTMLForm
	instanceVariableNames:'widgets values maxHeight'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Documentation'
!


!HTMLForm methodsFor:'accessing'!

addWidget:aWidgetElement
    widgets isNil ifTrue:[
        widgets := OrderedCollection new.
    ].
    widgets add:aWidgetElement

    "Created: 21.5.1996 / 15:34:29 / cg"
!

maxHeight
    "return maxHeight"

    ^ maxHeight

    "Created: 22.5.1996 / 13:42:36 / cg"
!

maxHeight:something
    "set maxHeight"

    maxHeight := something.

    "Created: 22.5.1996 / 13:42:36 / cg"
!

valueAt:name put:aValueHolder
    values isNil ifTrue:[
        values := (Dictionary new).
    ].
    values at:name put:aValueHolder

    "Created: 21.5.1996 / 15:32:36 / cg"
!

values
    values isNil ifTrue:[
        values := (Dictionary new).
    ].
    ^ values

    "Created: 21.5.1996 / 15:30:47 / cg"
!

values:aCollection
    values := aCollection

    "Created: 21.5.1996 / 15:30:47 / cg"
!

widgets
    ^ widgets

    "Created: 21.5.1996 / 21:00:49 / cg"
! !

!HTMLForm methodsFor:'queries'!

encTypeString
    ^ self parameterFor:'ENCTYPE' orLowerCase:'enctype'

    "Modified: 30.6.1996 / 16:01:20 / cg"
!

methodString
    ^ self parameterFor:'METHOD' orLowerCase:'method'

    "Modified: 30.6.1996 / 16:00:47 / cg"
! !

!HTMLForm  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/HTMLForm.st,v 1.4 1996-06-30 14:04:27 cg Exp $'
! !
