Object subclass:#HTMLMarkup
	instanceVariableNames:'type text origin'
	classVariableNames:'CommonMarkups MarkTypes'
	poolDictionaries:''
	category:'System-Documentation'
!


!HTMLMarkup  class methodsFor:'initialization'!

initialize
    CommonMarkups isNil ifTrue:[
        CommonMarkups := IdentityDictionary new.

        CommonMarkups at:#'/a' put:(self new type:#'/a').
        CommonMarkups at:#'/form' put:(self new type:#'/form').

        CommonMarkups at:#'html'  put:(self new type:#'html').
        CommonMarkups at:#'/html' put:(self new type:#'/html').
        CommonMarkups at:#'head'  put:(self new type:#'head').
        CommonMarkups at:#'/head' put:(self new type:#'/head').
        CommonMarkups at:#'body'  put:(self new type:#'body').
        CommonMarkups at:#'/body' put:(self new type:#'/body').
        CommonMarkups at:#'link'  put:(self new type:#'link').

        CommonMarkups at:#'title'  put:(self new type:#'title').
        CommonMarkups at:#'/title' put:(self new type:#'/title').

        CommonMarkups at:#'h1'    put:(self new type:#'h1').
        CommonMarkups at:#'/h1'   put:(self new type:#'/h1').
        CommonMarkups at:#'h2'    put:(self new type:#'h2').
        CommonMarkups at:#'/h2'   put:(self new type:#'/h2').
        CommonMarkups at:#'h3'    put:(self new type:#'h3').
        CommonMarkups at:#'/h3'   put:(self new type:#'/h3').
        CommonMarkups at:#'h4'    put:(self new type:#'h4').
        CommonMarkups at:#'/h4'   put:(self new type:#'/h4').
        CommonMarkups at:#'h5'    put:(self new type:#'h5').
        CommonMarkups at:#'/h5'   put:(self new type:#'/h5').
        CommonMarkups at:#'h6'    put:(self new type:#'h6').
        CommonMarkups at:#'/h6'   put:(self new type:#'/h6').

        CommonMarkups at:#'/dir'   put:(self new type:#'/dir').
        CommonMarkups at:#'/menu'  put:(self new type:#'/menu').
        CommonMarkups at:#'/dir'  put:(self new type:#'/dir').
        CommonMarkups at:#'/ul'   put:(self new type:#'/ul').
        CommonMarkups at:#'/ol'   put:(self new type:#'/ol').
        CommonMarkups at:#'/li'   put:(self new type:#'/li').

        CommonMarkups at:#'dd'    put:(self new type:#'dd').
        CommonMarkups at:#'/dd'   put:(self new type:#'/dd').
        CommonMarkups at:#'dt'    put:(self new type:#'dt').
        CommonMarkups at:#'/dt'   put:(self new type:#'/dt').
        CommonMarkups at:#'/dl'   put:(self new type:#'/dl').

        CommonMarkups at:#'hl'    put:(self new type:#'hl').
        CommonMarkups at:#'/hl'   put:(self new type:#'/hl').

        CommonMarkups at:#'b'     put:(self new type:#'b').
        CommonMarkups at:#'/b'    put:(self new type:#'/b').
        CommonMarkups at:#'i'     put:(self new type:#'i').
        CommonMarkups at:#'/i'    put:(self new type:#'/i').
        CommonMarkups at:#'u'     put:(self new type:#'u').
        CommonMarkups at:#'/u'    put:(self new type:#'/u').
        CommonMarkups at:#'tt'     put:(self new type:#'tt').
        CommonMarkups at:#'/tt'    put:(self new type:#'/tt').
        CommonMarkups at:#'big'     put:(self new type:#'big').
        CommonMarkups at:#'/big'    put:(self new type:#'/big').
        CommonMarkups at:#'small'     put:(self new type:#'small').
        CommonMarkups at:#'/small'    put:(self new type:#'/small').
        CommonMarkups at:#'sub'     put:(self new type:#'sub').
        CommonMarkups at:#'/sub'    put:(self new type:#'/sub').
        CommonMarkups at:#'sup'     put:(self new type:#'sup').
        CommonMarkups at:#'/sup'    put:(self new type:#'/sup').

        CommonMarkups at:#'address'   put:(self new type:#'address').
        CommonMarkups at:#'/address'  put:(self new type:#'/address').
        CommonMarkups at:#'abbrev'   put:(self new type:#'abbrev').
        CommonMarkups at:#'/abbrev'  put:(self new type:#'/abbrev').
        CommonMarkups at:#'acronym'   put:(self new type:#'acronym').
        CommonMarkups at:#'/acronym'  put:(self new type:#'/acronym').
        CommonMarkups at:#'au'   put:(self new type:#'au').
        CommonMarkups at:#'/au'  put:(self new type:#'/au').
        CommonMarkups at:#'blockquote'   put:(self new type:#'blockquote').
        CommonMarkups at:#'/blockquote'  put:(self new type:#'/blockquote').
        CommonMarkups at:#'cite'   put:(self new type:#'cite').
        CommonMarkups at:#'/cite'  put:(self new type:#'/cite').
        CommonMarkups at:#'code'   put:(self new type:#'code').
        CommonMarkups at:#'/code'  put:(self new type:#'/code').
        CommonMarkups at:#'del'   put:(self new type:#'del').
        CommonMarkups at:#'/del'  put:(self new type:#'/del').
        CommonMarkups at:#'dfn'   put:(self new type:#'dfn').
        CommonMarkups at:#'/dfn'  put:(self new type:#'/dfn').
        CommonMarkups at:#'em'    put:(self new type:#'em').
        CommonMarkups at:#'/em'   put:(self new type:#'/em').
        CommonMarkups at:#'ins'   put:(self new type:#'ins').
        CommonMarkups at:#'/ins'  put:(self new type:#'/ins').
        CommonMarkups at:#'kbd'   put:(self new type:#'kbd').
        CommonMarkups at:#'/kbd'  put:(self new type:#'/kbd').
        CommonMarkups at:#'lang'   put:(self new type:#'lang').
        CommonMarkups at:#'/lang'  put:(self new type:#'/lang').
        CommonMarkups at:#'person'   put:(self new type:#'person').
        CommonMarkups at:#'/person'  put:(self new type:#'/person').
        CommonMarkups at:#'q'   put:(self new type:#'q').
        CommonMarkups at:#'/q'  put:(self new type:#'/q').
        CommonMarkups at:#'s'   put:(self new type:#'s').
        CommonMarkups at:#'/s'  put:(self new type:#'/s').
        CommonMarkups at:#'samp'   put:(self new type:#'samp').
        CommonMarkups at:#'/samp'  put:(self new type:#'/samp').
        CommonMarkups at:#'strong'   put:(self new type:#'strong').
        CommonMarkups at:#'/strong'  put:(self new type:#'/strong').
        CommonMarkups at:#'var'   put:(self new type:#'var').
        CommonMarkups at:#'/var'  put:(self new type:#'/var').
        CommonMarkups at:#'blink'   put:(self new type:#'blink').
        CommonMarkups at:#'/blink'  put:(self new type:#'/blink').
        CommonMarkups at:#'center'   put:(self new type:#'center').
        CommonMarkups at:#'/center'  put:(self new type:#'/center').
        CommonMarkups at:#'font'   put:(self new type:#'font').
        CommonMarkups at:#'/font'  put:(self new type:#'/font').

        CommonMarkups at:#'pre'    put:(self new type:#'pre').
        CommonMarkups at:#'/pre'   put:(self new type:#'/pre').

        CommonMarkups at:#'hr'    put:(self new type:#'hr').
        CommonMarkups at:#'br'    put:(self new type:#'br').
        CommonMarkups at:#'wbr'   put:(self new type:#'wbr').
        CommonMarkups at:#'nobr'  put:(self new type:#'nobr').
        CommonMarkups at:#'/nobr' put:(self new type:#'/nobr').
        CommonMarkups at:#'p'     put:(self new type:#'p').
        CommonMarkups at:#'/p'    put:(self new type:#'/p').

        CommonMarkups at:#'/textarea' put:(self new type:#'/textarea').

        CommonMarkups at:#'caption' put:(self new type:#'caption').
        CommonMarkups at:#'/caption' put:(self new type:#'/caption').

        CommonMarkups at:#'/table' put:(self new type:#'/table').
        CommonMarkups at:#'th' put:(self new type:#'th').
        CommonMarkups at:#'tr' put:(self new type:#'tr').
        CommonMarkups at:#'/tr' put:(self new type:#'/tr').
        CommonMarkups at:#'td' put:(self new type:#'td').
        CommonMarkups at:#'/td' put:(self new type:#'/td').

        CommonMarkups at:#'map'  put:(self new type:#'map').
        CommonMarkups at:#'/map' put:(self new type:#'/map').
        CommonMarkups at:#'area'  put:(self new type:#'area').

        CommonMarkups at:#'tab'   put:(self new type:#'tab').
        CommonMarkups at:#'meta'  put:(self new type:#'meta').

        CommonMarkups at:#'/script' put:(self new type:#'/script').
        CommonMarkups at:#'/applet' put:(self new type:#'/applet').
        CommonMarkups at:#'/jwssuperapplet' put:(self new type:#'/jwssuperapplet').

        CommonMarkups at:#'bgsound' put:(self new type:#'bgsound').
        CommonMarkups at:#'frameset' put:(self new type:#'frameset').
        CommonMarkups at:#'/frameset' put:(self new type:#'/frameset').
        CommonMarkups at:#'frame' put:(self new type:#'frame').

        MarkTypes := IdentityDictionary new.

        MarkTypes at:#a        put:#HTMLAnchor.
        MarkTypes at:#img      put:#HTMLImage.
        MarkTypes at:#ul       put:#HTMLList.
        MarkTypes at:#ol       put:#HTMLList.
        MarkTypes at:#dl       put:#HTMLList.
        MarkTypes at:#dir      put:#HTMLList.
        MarkTypes at:#menu     put:#HTMLList.

        MarkTypes at:#li       put:#HTMLBullet.

        MarkTypes at:#form           put:#HTMLForm.
        MarkTypes at:#input          put:#HTMLWidget.
        MarkTypes at:#textarea       put:#HTMLWidget.
        MarkTypes at:#applet         put:#HTMLApplet.
        MarkTypes at:#jwssuperapplet put:#HTMLApplet.
        MarkTypes at:#table          put:#HTMLTable.
    ].

    "
     CommonMarkups := nil.
     HTMLMarkup initialize
    "

    "Modified: 5.9.1996 / 13:48:06 / cg"
! !

!HTMLMarkup  class methodsFor:'instance creation'!

for:aString
    "given a marks string (such as 'b', 'pre' or '/pre'),
     return a new markup instance"

    |sym m idx s rest clsSym cls|

    sym := aString asSymbolIfInterned.
    sym notNil ifTrue:[
        m := CommonMarkups at:sym ifAbsent:nil.
        m notNil ifTrue:[^ m]
    ].

    "/ only the very first word counts ...

    idx := aString withoutSeparators indexOfSeparatorStartingAt:1.
    idx == 0 ifTrue:[
        s := aString asLowercase
    ] ifFalse:[
        s := (aString copyTo:(idx-1)) asLowercase.
        rest := aString copyFrom:idx+1.
    ].

    "/ simple markup (no additional specs) is reused

    rest isNil ifTrue:[
        sym := s asSymbolIfInterned.
        sym notNil ifTrue:[
            m := CommonMarkups at:sym ifAbsent:nil.
            m notNil ifTrue:[^ m].

            clsSym := MarkTypes at:sym ifAbsent:nil.
            clsSym notNil ifTrue:[
                cls := Smalltalk at:clsSym ifAbsent:self
            ] ifFalse:[
                cls := self
            ].
            ^ cls new type:sym.
        ]
    ].

    sym := s asSymbolIfInterned.
    sym isNil ifTrue:[
        ('HTML: unknown mark: ' , s) infoPrintCR.
        ^ HTMLMarkupText new text:aString.
"/        sym := s.
    ].

    (CommonMarkups includesKey:sym) ifFalse:[
        (MarkTypes includesKey:sym) ifFalse:[
            ('HTML: unknown mark: ' , s) infoPrintCR.
            ^ HTMLMarkupText new text:aString.
        ]
    ].

    clsSym := MarkTypes at:sym ifAbsent:nil.
    clsSym notNil ifTrue:[
        cls := Smalltalk at:clsSym ifAbsent:self
    ] ifFalse:[
        cls := self
    ].
    ^ cls new type:sym text:rest

    "Modified: 21.5.1996 / 15:18:29 / cg"
! !

!HTMLMarkup  class methodsFor:'helpers'!

parameterFor:keyword from:text
    ^ self parameterFor:keyword orLowerCase:keyword asLowercase from:text

    "Created: 12.6.1996 / 19:33:13 / cg"
    "Modified: 18.6.1996 / 21:33:57 / cg"
!

parameterFor:keyword orLowerCase:lcKeyword from:text
    |idx nm sIdx eIdx previousCharacter|

    text isNil ifTrue:[^ nil].

    (idx := text findString:keyword) == 0 ifTrue:[
        (idx := text findString:lcKeyword) == 0 ifTrue:[
            (idx := text asLowercase findString:lcKeyword) == 0 ifTrue:[
                ^ nil
            ]
        ]
    ].

    "/ avoid detecting a substring as parameter

    idx ~~ 1 ifTrue:[
        previousCharacter := text at:(idx - 1).
        previousCharacter isLetter ifTrue:[^ nil].
    ].

    "/ look for more
    idx := idx+keyword size.
    [idx < text size and:[(text at:idx) isSeparator]] whileTrue:[
        idx := idx + 1
    ].
    (idx > text size or:[(text at:idx) ~= $=]) ifTrue:[
        ^ nil
    ].
    idx := idx + 1.

    nm := (text copyFrom:idx) withoutSeparators.
    (nm startsWith:$") ifTrue:[
        eIdx := nm indexOf:$" startingAt:2.
        sIdx := 2.
    ] ifFalse:[
        (nm startsWith:$') ifTrue:[
            eIdx := nm indexOf:$' startingAt:2.
            sIdx := 2.
        ] ifFalse:[
            eIdx := nm indexOfSeparatorStartingAt:1.
            sIdx := 1.
        ].
    ].
    eIdx == 0 ifTrue:[
        eIdx := nm size + 1.
    ].
    nm := nm copyFrom:sIdx to:eIdx-1.

    ^ nm.

    "Created: 12.6.1996 / 19:32:04 / cg"
    "Modified: 18.6.1996 / 21:03:44 / cg"
    "Modified: 5.8.1996 / 09:05:22 / stefan"
! !

!HTMLMarkup methodsFor:'accessing'!

bounds
    ^ nil

    "Created: 21.5.1996 / 11:14:26 / cg"
!

colorParameter
    ^ self colorParameter:'COLOR'

    "Modified: 12.6.1996 / 18:15:19 / cg"
!

colorParameter:keyword
    |clrSpec clr|

    clrSpec := self parameterFor:keyword.
    clrSpec notNil ifTrue:[
        clr := Color name:clrSpec ifIllegal:[('HTML: invalid color spec: ' , clrSpec) infoPrintCR.
                                             nil.].
        clr isNil ifTrue:[
            "/ netscape seems to accept xxxx instead of #xxxx as well ...
            clr := Color name:('#' , clrSpec) ifIllegal:nil
        ].
        clr notNil ifTrue:[
            ^ clr
        ].
        ('HTML: invalid color spec: ' , clrSpec) infoPrintCR
    ].
    ^ nil

    "Created: 12.6.1996 / 18:15:07 / cg"
    "Modified: 18.6.1996 / 18:29:45 / cg"
!

hasParameterFor:keyword
    ^ self hasParameterFor:keyword orLowerCase:keyword asLowercase

    "Created: 13.6.1996 / 17:27:09 / cg"
!

hasParameterFor:keyword orLowerCase:lcKeyword
    |idx nm sIdx eIdx|

    text isNil ifTrue:[^ false].

    (idx := text findString:keyword) == 0 ifTrue:[
        (idx := text findString:lcKeyword) == 0 ifTrue:[
            (idx := text asLowercase findString:lcKeyword) == 0 ifTrue:[
                ^ false
            ]
        ]
    ].
    ^ true

    "Created: 23.5.1996 / 08:37:15 / cg"
    "Modified: 18.6.1996 / 18:07:07 / cg"
!

numericParameterFor:keyword
    ^ self numericParameterFor:keyword default:nil

    "Created: 24.5.1996 / 12:35:54 / cg"
    "Modified: 13.6.1996 / 17:27:35 / cg"
!

numericParameterFor:keyword default:default
    ^ self numericParameterFor:keyword orLowerCase:keyword asLowercase default:default

    "Created: 24.5.1996 / 15:04:31 / cg"
    "Modified: 13.6.1996 / 17:27:41 / cg"
!

numericParameterFor:keyword orLowerCase:lcKeyword default:default
    |s val|

    text isNil ifTrue:[^ default].
    s := self parameterFor:keyword orLowerCase:lcKeyword.
    s isNil ifTrue:[^ default].

    s := s readStream.
    val := Integer readFrom:s onError:default.
    s next == $% ifTrue:[
        ^ val asFloat
    ].
    ^ val

    "Created: 21.5.1996 / 15:20:43 / cg"
    "Modified: 18.6.1996 / 18:37:27 / cg"
!

origin
    "return origin"

    ^ origin

    "Created: 3.6.1996 / 15:54:48 / cg"
!

origin:something
    "set origin"

    origin := something.

    "Created: 3.6.1996 / 15:54:48 / cg"
!

parameterFor:keyword
    text isNil ifTrue:[^ nil].
    ^ self class parameterFor:keyword from:text

    "Modified: 12.6.1996 / 19:33:38 / cg"
!

parameterFor:keyword orLowerCase:lcKeyword
    text isNil ifTrue:[^ nil].
    ^ self class parameterFor:keyword orLowerCase:lcKeyword from:text

    "Modified: 12.6.1996 / 19:32:29 / cg"
!

text
    "return the markups text, if any"

    ^ text

    "Created: 20.5.1996 / 12:21:41 / cg"
    "Modified: 20.5.1996 / 12:21:57 / cg"
!

text:aString
    "set the markups text"

    text := aString

    "Modified: 16.5.1996 / 13:05:25 / cg"
    "Created: 20.5.1996 / 12:21:53 / cg"
!

type
    "return the markups type, a symbol"

    ^ type

    "Created: 16.5.1996 / 13:05:14 / cg"
    "Modified: 16.5.1996 / 13:05:25 / cg"
!

type:aSymbol
    "set the markups type to aSymbol"

    type := aSymbol.

    "Created: 16.5.1996 / 13:05:14 / cg"
    "Modified: 16.5.1996 / 13:05:41 / cg"
!

type:aSymbol text:aString
    "set the markups type to aSymbol and textInfo to aString"

    type := aSymbol.
    text := aString.

    "Created: 16.5.1996 / 13:05:14 / cg"
    "Modified: 16.5.1996 / 13:05:41 / cg"
! !

!HTMLMarkup methodsFor:'printing & storing'!

displayString
    type isNil ifTrue:[^ super displayString].
    ^ 'a ' , self class name , '(<' , type printString , '>)'

    "Modified: 21.5.1996 / 15:18:24 / cg"
! !

!HTMLMarkup methodsFor:'queries'!

actionString
    ^ self parameterFor:'ACTION' orLowerCase:'action'

    "Created: 21.5.1996 / 19:08:10 / cg"
    "Modified: 18.6.1996 / 20:58:42 / cg"
!

boundsTop
    ^ nil

    "Created: 21.5.1996 / 11:14:33 / cg"
!

nameString
    ^ self parameterFor:'NAME' orLowerCase:'name'

    "Created: 18.6.1996 / 20:59:14 / cg"
!

typeString
    ^ self parameterFor:'TYPE' orLowerCase:'type'

    "Created: 20.5.1996 / 18:39:52 / cg"
    "Modified: 18.6.1996 / 20:58:47 / cg"
! !

!HTMLMarkup  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/HTMLMarkup.st,v 1.24 1996-09-05 17:53:06 cg Exp $'
! !
HTMLMarkup initialize!
